from math import *

def example_moving_average():
    mv = Moving_Average(10, 10.0)
    for i in range(0, 5):
        print "AVG=%8.3f , QUEUE = %s" % (mv.update(i), mv.queue())
    
def sign(x):
    if x!=0:
        return x/abs(x)
    else:
        return 1

def radian(deg):
    return deg*pi/180

def degree(rad):
    return rad*180/pi

class Moving_Average:
    def __init__(self, size, init_val=0.0):
        self.__size = size
        self.__queue = []
        self.__sum = init_val*size
        for i in range(0, size):
            self.__queue.append(init_val)

    def update(self, val):
        self.__queue.append(val)
        pop_val = self.__queue.pop(0)
        self.__sum = self.__sum-pop_val+val
        return self.__sum/self.__size

    def queue(self):
        return self.__queue


if __name__ == '__main__':
    print "EXAMPLE - Moving_Average"
    example_moving_average()
